unit CabComboBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TCabComboBox = class(TComboBox)
  private
    { Private declarations }
    FCharCase : TEditCharCase;
    FNumericOnly : Boolean;
    FEnterAsTab : Boolean;
    function GetEnterAsTab : Boolean;
    procedure SetEnterAsTab(Value : Boolean);
    function GetCharCase : TEditCharCase;
    procedure SetCharCase(Value : TEditCharCase);
    function GetNumericOnly : Boolean;
    procedure SetNumericOnly(Value : Boolean);
  protected
    { Protected declarations }
    procedure KeyPress(var Key: Char); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
  public
    { Public declarations }
  published
    { Published declarations }
    property CharCase : TEditCharCase read GetCharCase
      write SetCharCase;
    property NumericOnly : Boolean read GetNumericOnly
       write SetNumericOnly;
    property EnterAsTab : Boolean read GetEnterAsTab
       write SetEnterAsTab;
  end;

procedure Register;

implementation

procedure TCabComboBox.KeyPress(var Key: Char);
var
   MYForm: TCustomForm;
begin
   if FNumericOnly and (not (Key in [#13, '0'..'9'])) then
      Key := #0;
   case FCharCase of
      ecNormal :;
      ecUpperCase : Key := UpCase(Key);
      ecLowerCase : if Key in ['A'..'Z'] then
         Key := chr(ord(Key) + (ord('a') - ord('A')));
   end;
   if FEnterAsTab and (Key = #13) then begin
       MYForm := GetParentForm( Self );
       if not (MYForm = nil ) then
           SendMessage(MYForm.Handle, WM_NEXTDLGCTL, 0, 0);
       Key := #0;
   end;
   if Key <> #0 then
      inherited KeyPress(Key);
end;

procedure TCabComboBox.KeyDown(var Key: Word; Shift: TShiftState);
var
   MYForm: TCustomForm;
   CtlDir: Word;
begin
   if (Key = VK_UP) or (Key = VK_DOWN) then begin
      MYForm := GetParentForm( Self );
      if Key = VK_UP then
         CtlDir := 1
      else
         CtlDir :=0;
      if not (MYForm = nil ) then
         SendMessage(MYForm.Handle, WM_NEXTDLGCTL, CtlDir, 0);
   end
   else
      inherited KeyDown(Key, Shift);
end;

function TCabComboBox.GetCharCase : TEditCharCase;
begin
   result := FCharCase;
end;

procedure TCabComboBox.SetCharCase(Value : TEditCharCase);
begin
   FCharCase := Value;
end;

function TCabComboBox.GetNumericOnly : Boolean;
begin
   Result := FNumericOnly;
end;

procedure TCabComboBox.SetNumericOnly(Value : Boolean);
begin
   FNumericOnly := Value;
end;

function TCabComboBox.GetEnterAsTab : Boolean;
begin
   Result := FEnterAsTab;
end;

procedure TCabComboBox.SetEnterAsTab(Value : Boolean);
begin
   FEnterAsTab := Value;
end;

procedure Register;
begin
  RegisterComponents('Cabarrus Components', [TCabComboBox]);
end;

end.
